<template lang="pug">
md-card.md-scrollbar
  md-card-header
    md-avatar
      img(:src="selectedUser.picture.thumbnail")
    md-button.md-icon-button.right-button.md-accent(v-if="isFavourite" @click="setFavourite")
      md-icon.fa.fa-heart
    md-button.md-icon-button.right-button(v-else @click="setFavourite")
      md-icon.fa.fa-heart
  md-card-media
    #map.map-container
  md-card-content
    .md-title Datos personales
    p Nombre: {{ selectedUser.name.first }} {{ selectedUser.name.last }}
    p Email: {{ selectedUser.email }}
  md-card-content
    .md-title Datos de localización
    p Ciudad: {{ selectedUser.location.city }}
    p Calle: {{ selectedUser.location.street.name }}, {{ selectedUser.location.street.number }}
    p Teléfonos: {{ selectedUser.phone }}, {{ selectedUser.cell }}
</template>

<script>
export default {
  name: "Vista2",
  data() {
    return {
    };
  },
  mounted() {
    var map = L.map("map").setView(this.center, 15);
    L.tileLayer("http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png", {
      attribution:
        'Map data &copy; <a href="http://openstreetmap.org">OpenStreetMap</a> contributors, <a href="http://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="http://cloudmade.com">CloudMade</a>',
      maxZoom: 18,
    }).addTo(map);
    const myIcon = L.icon({
      iconUrl: '../assets/marker-icon.png'
    });
    L.marker(this.center, { icon: myIcon, draggable: false }).addTo(map);
  },
  methods: {
    setFavourite () {
      if (!this.isFavourite) {
        this.$store.commit('addFavourite', this.selectedUser);
      } else {
        const idx = this.$store.state.favouriteUsers.findIndex(x => x.email === this.selectedUser.email);
        this.$store.commit('deleteFavourite', idx);

      }
    }
  },
  computed: {
    selectedUser () {
      return this.$store.state.selectedUser;
    },
    center () {
      if (!this.selectedUser) {
        return [47.41322, -1.219482];
      } else {
        return [
          this.selectedUser.location.coordinates.latitude,
          this.selectedUser.location.coordinates.longitude,
        ];
      }
    },
    isFavourite () {
      return this.$store.state.favouriteUsers.findIndex(x => x.email === this.selectedUser.email) !== -1;
    }
  },
};
</script>

<style scoped>
/* .md-content {
  max-height: 80vh;
  overflow: auto;
} */
.right-button {
  float: right;
}
.width-50 {
  width: 50%;
}
.map-container {
  height: 200px;
}
.color-red {
  color: red;
  background-color: red;
}
</style>
